#include "cpu_check.h"

static inline void cpuid(int code, uDWord* a, uDWord* d) {
    asm volatile("cpuid" : "=a"(*a), "=d"(*d) : "0"(code) : "ecx", "ebx");
}

/**
 * Reads the CPU registers into the regs array.
 * Returns in following order: EAX, EBX, ECX, EDX, ESI, EDI, ESP, EBP.
 *
 * @param A buffer of size 8.
 */
void cpu_get_registers(uQWord* regs) {
    asm("movl %%eax, %0" : "=r"(*(regs++)));
    asm("movl %%ebx, %0" : "=r"(*(regs++)));
    asm("movl %%ecx, %0" : "=r"(*(regs++)));
    asm("movl %%edx, %0" : "=r"(*(regs++)));
    asm("movl %%esi, %0" : "=r"(*(regs++)));
    asm("movl %%edi, %0" : "=r"(*(regs++)));
    asm("movl %%esp, %0" : "=r"(*(regs++)));
    asm("movl %%ebp, %0" : "=r"(*(regs++)));
}
