#include "init.h"
#include "panic.h"
#include "errors.h"
#include "textmode.h"
#include "../lib/stdio.h"

void kprint_header() {
    kset_textcol(TEXTMODE_WHITE, TEXTMODE_GREEN);
    kclear_screen();
    kprint("-= Bella Operating System ");
    kprint_kernel_version();
    kprint(" =-");
    kprint_fill('-');
    kprint("Compiled on ");
    kprint_kernel_compiledatetime();
}

/**
 * This is the kernel's main entry point.
 * It is not expected to return from this method, therefore a kernel
 * panic will be issued if this happens.
 */
int kmain() {
    kinit();
    kprint_header();

    PANIC(KERR_UNEXPECTED_END, "Unexpected return to kmain.");

    return 0xCAFFEE;
}
