#ifndef TEXTMODE_H_
#define TEXTMODE_H_

#include "types.h"

// Text mode memory base address
#define TEXTMODE_MEMBASE        0xB8000

// Text mode color definitions ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define TEXTMODE_BLACK          0
#define TEXTMODE_BLUE           1
#define TEXTMODE_GREEN          2
#define TEXTMODE_CYAN           3
#define TEXTMODE_RED            4
#define TEXTMODE_MAGENTA        5
#define TEXTMODE_BROWN          6
#define TEXTMODE_LIGHTGREY      7
#define TEXTMODE_DARKGREY       8
#define TEXTMODE_LIGHTBLUE      9
#define TEXTMODE_LIME           10
#define TEXTMODE_LIGHTCYAN      11
#define TEXTMODE_ORANGE         12
#define TEXTMODE_PINK           13
#define TEXTMODE_YELLOW         14
#define TEXTMODE_WHITE          15

void kclear_screen();
void kprint(const char* txt);
void kprint_fill(char chr);
void kprint_int(int number, uByte base);
void kset_textcol(uByte fgCol, uByte bgCol);
inline void kprint_hex(int number);
inline void kprint_dec(int number);
inline void kprint_oct(int number);
inline void kprint_bin(int number);
void kprint_kernel_version();
void kprint_kernel_compiledatetime();

#endif /*TEXTMODE_H_*/
