#include "string.h"

inline int is_digit(char chr) {
    return (chr >= '0') && (chr <= '9');
}

inline int is_letter(char chr) {
    return ((chr >= 'A') && (chr <= 'Z')) ||
           ((chr >= 'a') && (chr <= 'z'));
}

inline int is_whitespace(char chr) {
    switch(chr) {
    case ' ':
    case '\n':
    case '\r':
    case '\t':
        return 1;
    }

    return 0;
}

inline char chrupr(char chr) {
    return ((chr >= 'a') && (chr <= 'z')) ? chr - ('a' - 'A') : chr;
}

inline char chrlwr(char chr) {
    return ((chr >= 'A') && (chr <= 'Z')) ? chr + ('a' - 'A') : chr;
}

uQWord strlen(char* str) {
    uQWord len = 0;

    while(*str++) {
        len++;
    }
    
    return len;
}

/**
 * Converts the passed string to upper case in place.
 * Please note, that this works only for ASCII characters from a-z!
 *
 * @param str The string to convert.
 */
void strupr(char* str) {
    while(*str) {
        if((*str >= 'a') && (*str <= 'z')) {
            *str -= 'a' - 'A';
        }

        ++str;
    }
}

/**
 * Converts the passed string to lower case in place.
 * Please note, that this works only for ASCII characters from A-Z!
 *
 * @param str The string to convert.
 */
void strlwr(char* str) {
   while(*str) {
       if((*str >= 'A') && (*str <= 'Z')) {
           *str += 'a' - 'A';
       }

       ++str;
   }
}
